define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'task/steps/index' + location.search,
                    add_url: 'task/steps/add',
                    edit_url: 'task/steps/edit',
                    del_url: 'task/steps/del',
                    multi_url: 'task/steps/multi',
                    import_url: 'task/steps/import',
                    table: 'task_steps',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'weigh',
                fixedColumns: true,
                fixedRightNumber: 1,
                columns: [
                    [
                        {field: 'state', checkbox: true,},
                        {field: 'id', title: 'ID'},
                        {
                            field: 'name',
                            title: __('名称'),
                            align: 'left',
                        },
                        {field: 'start_time', title: __('开始时间'), align: 'left',},
                        {field: 'end_time', title: __('结束时间'), align: 'left'},
                        {
                            field: 'operate',
                            title: __('Operate'),
                            table: table,
                            events: Table.api.events.operate,
                            formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        a:function () {
        // 初始化表格参数配置
        Table.api.init({
            extend: {
                "index_url": "task/task/detail",
                "add_url": "auth/rule/add",
                "edit_url": "auth/rule/edit",
                "del_url": "auth/rule/del",
                "multi_url": "auth/rule/multi",
                "table": "task_steps"
            }
        });

        var table = $("#table");

        // 初始化表格
        table.bootstrapTable({
            url: $.fn.bootstrapTable.defaults.extend.index_url,
            sortName: '',
            escape: false,
            columns: [
                [
                    {field: 'state', checkbox: true,},
                    {field: 'id', title: 'ID'},
                    {
                        field: 'name',
                        title: __('名称'),
                        align: 'left',
                    },
                    // {field: 'start-time', title: __('开始时间'), align: 'left',},
                    // {field: 'end-time', title: __('结束时间'), align: 'left'},
                    {
                        field: 'operate',
                        title: __('Operate'),
                        table: table,
                        events: Table.api.events.operate,
                        formatter: Table.api.formatter.operate
                    }
                ]
            ],
            pagination: false,
            search: false,
            commonSearch: false,
            rowAttributes: function (row, index) {
                return row.pid == 0 ? {} : {style: "display:none"};
            }
        });

        // 为表格绑定事件
        Table.api.bindevent(table);

        var btnSuccessEvent = function (data, ret) {
            if ($(this).hasClass("btn-change")) {
                var index = $(this).data("index");
                var row = Table.api.getrowbyindex(table, index);
                row.ismenu = $("i.fa.text-gray", this).length > 0 ? 1 : 0;
                table.bootstrapTable("updateRow", {index: index, row: row});
            } else if ($(this).hasClass("btn-delone")) {
                if ($(this).closest("tr[data-index]").find("a.btn-node-sub.disabled").length > 0) {
                    $(this).closest("tr[data-index]").remove();
                } else {
                    table.bootstrapTable('refresh');
                }
            } else if ($(this).hasClass("btn-dragsort")) {
                table.bootstrapTable('refresh');
            }
            Fast.api.refreshmenu();
            return false;
        };

        //表格内容渲染前
        table.on('pre-body.bs.table', function (e, data) {
            var options = table.bootstrapTable("getOptions");
            options.escape = true;
        });

        //当内容渲染完成后
        table.on('post-body.bs.table', function (e, data) {
            var options = table.bootstrapTable("getOptions");
            options.escape = false;

            //点击切换/排序/删除操作后刷新左侧菜单
            $(".btn-change[data-id],.btn-delone,.btn-dragsort").data("success", btnSuccessEvent);

        });

        table.on('post-body.bs.table', function (e, settings, json, xhr) {
            //显示隐藏子节点
            $(">tbody>tr[data-index] > td", this).on('click', "a.btn-node-sub", function () {
                var status = $(this).data("shown") ? true : false;
                $("a[data-pid='" + $(this).data("id") + "']").each(function () {
                    $(this).closest("tr").toggle(!status);
                });
                if (status) {
                    $("a[data-pid='" + $(this).data("id") + "']").trigger("collapse");
                }
                $(this).data("shown", !status);
                $("i", this).toggleClass("fa-caret-down").toggleClass("fa-caret-right");
                return false;
            });
        });

        //隐藏子节点
        $(document).on("collapse", ".btn-node-sub", function () {
            if ($("i", this).length > 0) {
                $("a[data-pid='" + $(this).data("id") + "']").trigger("collapse");
            }
            $("i", this).removeClass("fa-caret-down").addClass("fa-caret-right");
            $(this).data("shown", false);
            $(this).closest("tr").toggle(false);
        });

        //批量删除后的回调
        $(".toolbar > .btn-del,.toolbar .btn-more~ul>li>a").data("success", function (e) {
            Fast.api.refreshmenu();
        });

        //展开隐藏一级
        $(document.body).on("click", ".btn-toggle", function (e) {
            $("a[data-id][data-pid][data-pid!=0].disabled").closest("tr").hide();
            var that = this;
            var show = $("i", that).hasClass("fa-chevron-down");
            $("i", that).toggleClass("fa-chevron-down", !show).toggleClass("fa-chevron-up", show);
            $("a[data-id][data-pid][data-pid!=0]").not('.disabled').closest("tr").toggle(show);
            $(".btn-node-sub[data-pid=0]").data("shown", show);
        });

        //展开隐藏全部
        $(document.body).on("click", ".btn-toggle-all", function (e) {
            var that = this;
            var show = $("i", that).hasClass("fa-plus");
            $("i", that).toggleClass("fa-plus", !show).toggleClass("fa-minus", show);
            $(".btn-node-sub:not([data-pid=0])").closest("tr").toggle(show);
            $(".btn-node-sub").data("shown", show);
            $(".btn-node-sub > i").toggleClass("fa-caret-down", show).toggleClass("fa-caret-right", !show);
        });
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});
